Lua_FightButtonItem = class("Lua_FightButtonItem", Lua_ListCell);
function Lua_FightButtonItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_FightButtonItem:buildShowItem()
	self:superCall("buildShowItem");
	self.icon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.icon:addClickFuntion(self, self.onPressClick);

	self:addLuaEvent("fightPlay_speed_change", self, self.onSpeedChange);
end

function Lua_FightButtonItem:dispose()
	self:superCall("dispose");
end

function Lua_FightButtonItem:setData(data)
	self.data = data;
	if data == 0 then -- 加速
		self.icon:setAltas("fight_atlas_1", "ui_zd_button_014_n");
	elseif data == 1 then -- 跳过
		self.icon:setAltas("fight_atlas_1", "ui_zd_button_018_n");
	elseif data == 2 then -- BUFF
		self.icon:setAltas("fight_atlas_1", "ui_zd_button_020_n");
	elseif data == 3 then -- 暂停
		self.icon:setAltas("fight_atlas_1", "ui_zd_button_019_n");
	elseif data == 4 then -- 挂起
		self.icon:setAltas("fight_atlas_1", "ui_zd_button_021_n");
	elseif data == 8 then -- 分队信息
		self.icon:setAltas("fight_atlas_1", "ui_zd_button_020_n");
	end
end

function Lua_FightButtonItem:onSpeedChange(showSpeed)
	if self.data == 0 then
		self.icon:setAltas("fight_atlas_1", "ui_zd_button_01"..(showSpeed + 3).."_n");
	end
end

function Lua_FightButtonItem:onPressClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.3 then
		return;
	end
	self.clickTime = getTime();
	Lua_MsgUtil.callFunc("FIGHT_BUTTON_CLICK", self.data);
end