-- 战斗
checkRequire("Lua_LineupAureoleIconItem");
checkRequire("Lua_FightButtonItem");
checkRequire("Lua_FightRoleSkillCoolItem");
checkRequire("Lua_FightIntoEffShowPanel"); -- 开始特效
checkRequire("Lua_FightBossHurtPanel"); -- BOSS伤害
checkRequire("Lua_FightStarPanel"); -- 战斗星级
checkRequire("Lua_FightGradePanel"); -- 战斗评级
checkRequire("Lua_FightTeamPanel"); -- 战斗组队
Lua_FightMainWindow = class("Lua_FightMainWindow", Lua_Window);
function Lua_FightMainWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.windowName = "Lua_FightMainWindow";
	self.skinName = "FightMainWindow_skin";
	self.isFullSizeWin = true;
	self.isSingleShowWin = true;
end

function Lua_FightMainWindow:buildPanel(go)
	self:superCall("buildPanel", go);
	self:addLuaEvent("FIGHT_ARTIFACT_UPDATE", self, self.onUpdateArtifact);
	self:addLuaEvent("fight_camp_change", self, self.onCampChange);
	self:addLuaEvent("fightPlay_speed_change", self, self.onSpeedChange);
	self:addLuaEvent("fight_enter_scene", self, self.onUpdateRecordInfo);
	self:addLuaEvent("fight_execute_action", self, self.onUpdateExecuteActionInfo);
	self:addLuaEvent("skillAttackHurtUpdate", self, self.onSkillHurtUpdate);
	self:addLuaEvent("fight_roleSkill_update", self, self.onUpdateRoleSkill);
	self:addLuaEvent("FIGHTPLAY_CHECK_UPDATE", self, self.onUpdateCheck);
	self:addLuaEvent("FIGHT_BUTTON_CLICK", self, self.onButtonClick);
end

function Lua_FightMainWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.curAction = 1; -- 当前行动
	self.curRound = 1; -- 当前回合
	self.curRotation = 1; -- 当前轮次

	self.rotationObj:SetActive(false);
	self.roundObj:SetActive(false);
	self.hurtObj:SetActive(false);
	self.artifactObj:SetActive(false);
	self.skillObj_1:SetActive(false);
	self.skillObj_2:SetActive(false);

	LuaUtil.setObjPos(self.maskObj, 0, GlobalVar.screenOffsetTopH / 2, 0);
	self.maskObj:SetActive(false);
	self.pauseMask:SetDimensions(self.width, MainWinDefine.V_height);
	self.pauseMask:addClickFuntion(self, self.onBlackMaskClick);

	self.leftEmbattleItem = Lua_LineupAureoleIconItem.new(self.topObject);
	self.leftEmbattleItem:setLocation(-311, -44.5, 0);

	self.rightEmbattleItem = Lua_LineupAureoleIconItem.new(self.topObject);
	self.rightEmbattleItem:setLocation(308, -44.5, 0);
	
	-- 关闭布阵界面
	Lua_WindowUtil.openWin("Lua_FightLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_InfinityHallIndividualWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_InfinityHallTeamWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_TowerLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_StarTrialLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_NewHeroActStoryLineupWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_PeakDuelMatchWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_EquipCopyLineupWindow", Lua_WinParam.ACTION_CLOSE);	--关闭寂灭岛布阵界面
	Lua_WindowUtil.openWin("Lua_TeamSaloonWindow", Lua_WinParam.ACTION_CLOSE); -- 关闭寂灭岛组队界面
	Lua_WindowUtil.openWin("Lua_HeroLineupWindow", Lua_WinParam.ACTION_CLOSE);
end

function Lua_FightMainWindow:dispose()
	if self.startEffPanel ~= nil then -- 移除开始动画
		self.startEffPanel:dispose();
		self.startEffPanel = nil;
	end

	self._recordVo = nil;
	TweenUtil.getInstance():stop(self.skillObj_1);
	TweenUtil.getInstance():stop(self.skillObj_2);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	Lua_CommonUtil.removeTimer(self, self.onOverStartEffShow);
	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);

	Lua_WindowUtil.openWin("Lua_InfinityHallBuffWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightOverallBuffWindow", Lua_WinParam.ACTION_CLOSE);
	Lua_WindowUtil.openWin("Lua_FightQueueWindow", Lua_WinParam.ACTION_CLOSE);

	if self.leftEmbattleItem ~= nil then
		self.leftEmbattleItem:dispose();
		self.leftEmbattleItem = nil;
	end

	if self.rightEmbattleItem ~= nil then
		self.rightEmbattleItem:dispose();
		self.rightEmbattleItem = nil;
	end

	self:clearPanel()
	if self.operateList then
		self.operateList:dispose()
		self.operateList:clear()
		self.operateList = nil
	end

	if self.roleSkillArr ~= nil then
		self.roleSkillArr:dispose();
		self.roleSkillArr:clear();
		self.roleSkillArr = nil;
	end

	self:superCall("dispose");
end

function Lua_FightMainWindow:onScreenResize()
	self:superCall("onScreenResize");
	LuaUtil.setObjPos(self.maskObj, 0, GlobalVar.screenOffsetTopH / 2, 0);
	self.pauseMask:SetDimensions(self.width, MainWinDefine.V_height);
end

function Lua_FightMainWindow:showWin(param)
	self:superCall("showWin", param);

	local removeFightId = DataCenter.fightData.removeFightId
	if removeFightId and param ~= removeFightId then
		DataCenter.fightData:removeFight(removeFightId, false)
		DataCenter.fightData.removeFightId = nil
	end

	-- 防止多次点击跳过按钮、挂起按钮
	self.isPressSkip = nil;
	self.isPressHang = nil;

	local recordVo = DataCenter.fightData:getRecordVoById(param);
	-- 结算界面直接挑战下一层/下一关，关闭结算界面
	local config = Lua_FightTemplateConfigData.getConfigData(recordVo.templateId)
	if config.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then
		Lua_WindowUtil.openWin("Lua_MainLineFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	elseif recordVo.templateId == 1004 or recordVo.templateId == 1007 or recordVo.templateId == 1008 or recordVo.templateId == 1009 or recordVo.templateId == 1010 then
		Lua_WindowUtil.openWin("Lua_ClimbTowerFightWinWindow", Lua_WinParam.ACTION_CLOSE, nil, true);
	end

	-- 布阵开始战斗后立即关闭，这时战斗场景被关闭，因此设置该战斗后台播放
	if not Scene3DManager.instance:isShowSceneRoot(recordVo.sceneId, recordVo.recordId) then
		recordVo.bPlayedStartEff = true;
		DataCenter.fightData:hideFightToBackStageByRecordId(param);
		return;
	end
	self:onUpdateRecordInfo(param);
	self:showStartEff();
end

function Lua_FightMainWindow:onUpdateRecordInfo(rid)
	if self._recordId ~= rid then
		self._recordId = rid;
		self._recordVo = DataCenter.fightData:getRecordVoById(rid);
		if self._recordVo == nil then
			return;
		end
		self._maxRound = self._recordVo.maxRound;

		if self.templateId ~= self._recordVo.templateId then
			self:clearPanel()
		end
		self.templateId = self._recordVo.templateId
		self:createPanel()
		self:checkOperate()

		self:onSkillHurtUpdate(0)
		self:updateRoleInfo();
		local player = DataCenter.fightData:getFightPlayerById(self._recordId);
		if player ~= nil then
			self.curSession = player.curSession;
			self.curRotation = player.curRotation;
			self.curRound = player.curRound;
			self.curAction = player.curAction;
			self:onCampChange(player);
			self:onUpdateArtifact();
			self:onUpdateRoleSkill(player.roleSkillInfoList);
			self:onUpdateExecuteActionInfo(player.curPlayActionInfo);
		end
	end
end

function Lua_FightMainWindow:updateRoleInfo()
	if self._recordVo ~= nil then
		self.leftNameTxt.text = self._recordVo.attacker.name;
		if self._recordVo.defender == nil then
			self.rightNameTxt.text = nil;
		else
			self.rightNameTxt.text = self._recordVo.defender.name;
		end
	end
end

function Lua_FightMainWindow:onUpdateArtifact()
	local player = DataCenter.fightData:getFightPlayerById(self._recordId);
	if player == nil then
		return;
	end
	if player.role_artifact_id and player.role_artifact_id > 0 then
		local vo = DataCenter.artifactUtil:getArtifactVoById(player.role_artifact_id)
		self.artifactIcon:setEnable(true)
		self.artifactIcon:setAltas("raccoon_atlas_3", vo.icon_2)
		self.skill_icon_1:setUrl(vo.image_2)
	else
		self.artifactIcon:setEnable(false)
		self.skill_icon_1:setEnable(false)
	end
end

function Lua_FightMainWindow:onCampChange(player)
	if player == nil then
		player = DataCenter.fightData:getFightPlayerById(self._recordId);
	end
	if player ~= nil then
		self.leftEmbattleItem:setData(player.attackerCampList);
		self.rightEmbattleItem:setData(player.defenderCampList, self.templateId);
	end
end

function Lua_FightMainWindow:onUpdateExecuteActionInfo(info)
	if info == nil then
		return;
	end

	local bUpdateRoleSkill = false
	if self.curRound ~= info.round then
		bUpdateRoleSkill = true
	end
	self.curSession = info.session;
	self.curRotation = info.rotation;
	self.curRound = info.round;
	if bUpdateRoleSkill then
		self:updateRoleSkill()
	end

	self.rotationTxt.text = LanUtil.formateStr(302000, tostring(self.curRotation));

	if self._maxRound > 0 then
		self.roundTxt.text = LanUtil.formateStr(302001, tostring(info.round), tostring(self._maxRound));
	else
		self.roundTxt.text = LanUtil.formateStr(302002, tostring(info.round));
	end

	if self.gradePanel ~= nil then
		self.gradePanel:setData(self._recordId);
	end

	if self.teamPanel ~= nil then
		self.teamPanel:setData(self._recordId, self._recordVo.teamId);
	end
	
	if info.type == 2 then -- 释放技能
		local skillId = info.skill_id; -- 技能id
		local fighterId = tonumber(tostring(info.fighter_id));
		local skillCfg = Lua_SkillConfigData.getConfigData(skillId);
		local thing = DataCenter.thingData:getThingPlayer(self._recordVo.sceneId, self._recordId, fighterId);
		if skillCfg ~= nil and thing ~= nil then
			local kind = thing.player.data.kind;
			local formationType = thing.formationType;
			if kind == Lua_ThingDefine.PLAYER then
				self.skillObj_2:SetActive(false);
				if self.roleSkillDic ~= nil and self.roleSkillDic[skillId] ~= nil then
					self.roleSkillDic[skillId] = -1;

					self.skillObj_1:SetActive(true);
					self.skill_name_1.text = skillCfg.name;
					TweenUtil.getInstance():stop(self.skillObj_1);
					if formationType == Lua_FightDefine.FIGHT_ATTACKER then
						self:updateRoleSkill(); -- 释放神器技能

						self.skill_bg_1:setScale(1, 1, 1);
						self.skill_icon_1:setLocation(-112, 126, 0);
						self.skill_icon_1:setScale(0.7, 0.7, 0.7);
						self.skill_icon_2:setLocation(-146.5, 29, 0);
						self.skill_icon_2:setScale(1, 1, 1);
						self.skill_name_1:setLocation(223, -55.5, 0);

						self.skillHideX1 = 720;
						LuaUtil.setObjPos(self.skillObj_1, -720, -33, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, 0, -33, 0, 0, false);
					else
						self.skill_bg_1:setScale(-1, 1, 1);
						self.skill_icon_1:setLocation(112, 126, 0);
						self.skill_icon_1:setScale(-0.7, 0.7, 0.7);
						self.skill_icon_2:setLocation(146.5, 29, 0);
						self.skill_icon_2:setScale(-1, 1, 1);
						self.skill_name_1:setLocation(-223, -55.5, 0);

						self.skillHideX1 = -720;
						LuaUtil.setObjPos(self.skillObj_1, 720, -33, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, 0, -33, 0, 0, false);
					end
					Lua_CommonUtil.delayCall(1 / self._recordVo.speed, self, self.hideskillObj1);
				end
			else
				self.skillObj_1:SetActive(false);
				if skillCfg.skillType == 3 or skillCfg.skillType == 4 then
					self.skillObj_2:SetActive(true);
					self.skill_name_2.text = skillCfg.name;

					local md;
					local atlasName = nil;
					local spriteName = nil;
					if kind == Lua_ThingDefine.MONSTER then
				        md = Lua_MonsterConfigData.getMonsterConfig(thing.objId);
				    elseif kind == Lua_ThingDefine.HERO then
				        md = Lua_HeroConfigData.getConfig(thing.objId);
				    end

				    if md ~= nil then
						atlasName = md.avatar_atlas_2;
						spriteName = md.avatar_sprite_2;
					end
					self.heroAvatar:setAltas(atlasName, spriteName);
					self.heroAvatar:resetSize();
					
					TweenUtil.getInstance():stop(self.skillObj_2);
					if formationType == Lua_FightDefine.FIGHT_ATTACKER then
						self.skill_bg_2:setScale(1, 1, 1);
						self.heroAvatar:setScale(1, 1, 1);
						self.skill_name_2.pivotValue = 3;
						self.skill_name_2:setLocation(140, -1, 0);
						self.skill_name_2.alignmentValue = 3;

						self.skillHideX2 = -1080;
						self.skillHideY = 108;
						LuaUtil.setObjPos(self.skillObj_2, -1080, 108, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, -360, 108, 0, 0, false);
					else
						self.skill_bg_2:setScale(-1, 1, 1);
						self.heroAvatar:setScale(-1, 1, 1);
						self.skill_name_2.pivotValue = 5;
						self.skill_name_2:setLocation(-140, -1, 0);
						self.skill_name_2.alignmentValue = 5;
						self.skillHideX2 = 1080;
						self.skillHideY = 225;
						LuaUtil.setObjPos(self.skillObj_2, 1080, 225, 0);
						TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, 360, 225, 0, 0, false);
					end
					Lua_CommonUtil.delayCall(1 / self._recordVo.speed, self, self.hideskillObj2);
				end
			end
		end 
	end
end

function Lua_FightMainWindow:hideskillObj1()
	TweenUtil.getInstance():stop(self.skillObj_1);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj1);
	TweenUtil.getInstance():addTweenTargetPos(self.skillObj_1, 0.3 / self._recordVo.speed, 0, self.skillHideX1, -33, 0, 0, false);
end

function Lua_FightMainWindow:hideskillObj2()
	TweenUtil.getInstance():stop(self.skillObj_2);
	Lua_CommonUtil.removeTimer(self, self.hideskillObj2);
	TweenUtil.getInstance():addTweenTargetPos(self.skillObj_2, 0.3 / self._recordVo.speed, 0, self.skillHideX2, self.skillHideY, 0, 0, false);
end

function Lua_FightMainWindow:showStartEff()
	if self._recordVo == nil or self._recordVo.bPlayedStartEff == true then
		return;
	end

	self._recordVo.bPlayedStartEff = true;
	self.artifactObj:SetActive(false);
	if self.startEffPanel == nil then
		self.startEffPanel = Lua_FightIntoEffShowPanel.new(self.content);
		self.startEffPanel:setStart();
	end
	Lua_CommonUtil.removeTimer(self, self.onOverStartEffShow);
	Lua_CommonUtil.delayCall(DataCenter.fightUtil.startEffectTime, self, self.onOverStartEffShow);
end

function Lua_FightMainWindow:onOverStartEffShow()
	if self.startEffPanel ~= nil then -- 移除开始动画
		self.startEffPanel:dispose();
		self.startEffPanel = nil;
	end
	self:onUpdateRoleSkill();
end

function Lua_FightMainWindow:onSkillHurtUpdate(hurtVal)
	local player = DataCenter.fightData:getFightPlayerById(self._recordId);
	if player == nil or player.bRunBack == true then
		self.hurtObj:SetActive(false);
		Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);
		return;
	end

	local info = player.curPlayActionInfo;
	if info == nil or info.type ~= 2 then -- 非技能
		self.hurtObj:SetActive(false);
		Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);
		return;
	end

    if hurtVal > 0 then
    	self.hurtObj:SetActive(true);
		if self.hurtNum == nil then
			self.hurtNum = Lua_NumberImage.new(self.hurtObj);
			self.hurtNum:setLocation(150, 38, 0);
			self.hurtNum.pivot = 1;
			self.hurtNum.numOffsetX = -10;
			self.hurtNum.numAtlas = "number"
			self.hurtNum.preStr = "ui_zsh_number_0";
		end
		self.hurtNum.num = hurtVal;

    	if player.bPlaySkill == true then
    		Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);
    	else
    		Lua_CommonUtil.delayCall(0.3, self, self.onOverSkillHurtShow);
    	end
    else
    	Lua_CommonUtil.removeTimer(self, self.onOverSkillHurtShow);
    	self.hurtObj:SetActive(false);
    end 
end

function Lua_FightMainWindow:onOverSkillHurtShow()
	self.hurtObj:SetActive(false);
end

function Lua_FightMainWindow:onUpdateRoleSkill(list)
	if self.startEffPanel ~= nil then
		self.artifactObj:SetActive(false);
		return;
	end

	-- 不播放开场动画则更新主角技能
	if self._recordVo ~= nil and self._recordVo.bPlayedStartEff ~= true then
		self.artifactObj:SetActive(false);
		return;
	end

	if list == nil then
		local player = DataCenter.fightData:getFightPlayerById(self._recordId);
		if player ~= nil then
			list = player.roleSkillInfoList;
		end
	end

	if list == nil or #list <= 0 then
		self.artifactObj:SetActive(false);
		return;
	end

	self.roleSkillDic = {};
	for i = 1, #list do
		self.roleSkillDic[list[i].skill_id] = list[i].active_round;
	end
	self:updateRoleSkill();
end

function Lua_FightMainWindow:updateRoleSkill()
	if self.roleSkillDic ~= nil and self.curRound ~= nil then
		local val;
		local maxVal;
		local minNum = 9999;
		local maxNum = 1;
		local showskillCfg;
		for k, v in pairs(self.roleSkillDic) do
			local skillCfg = Lua_SkillConfigData.getConfigData(k);
			if skillCfg ~= nil then
				if v == -1 then
					minNum = -1;
					val = skillCfg.cool_round;
					maxVal = val;
				elseif v <= skillCfg.start_round then -- 首次
					val = skillCfg.start_round - (v - self.curRound);
					maxVal = skillCfg.start_round;
				else
					val = skillCfg.cool_round - (v - self.curRound);
					maxVal = skillCfg.cool_round;
				end

				if minNum > val then
					minNum = val;
					maxNum = maxVal;
					showskillCfg = skillCfg;
				end
			end
		end

		if showskillCfg ~= nil then
			self.artifactObj:SetActive(true);
			if showskillCfg.atlas ~= nil and showskillCfg.sprite ~= nil then
				self.artifactSkill:setEnable(true);
				self.artifactSkill:setAltas(showskillCfg.atlas, showskillCfg.sprite);
			else
				self.artifactSkill:setEnable(false);
			end

			if self.roleSkillArr == nil then
				self.roleSkillArr = Array();
			end
			local len = self.roleSkillArr:getSize();
			local maxLen = maxNum > len and maxNum or len;
			local space = 35.5
			local w = -(space * maxNum) / 2 + space / 2
			local item;
			for i = 1, maxLen do
				item = self.roleSkillArr[i];
				if i > maxNum then
					if item ~= nil then
						item:setEnable(false);
					end
				else
					if item == nil then
						item = Lua_FightRoleSkillCoolItem.new(self.artifactObj);
						self.roleSkillArr:add(item);
					else
						item:setEnable(true);
					end
					item:setShow(i <= minNum);
					item:setLocation(-158 + ((i - 1) % maxNum) * space + w, 10.5, 0);
				end
			end
		else
			if self.roleSkillArr ~= nil then
				for i = 1, self.roleSkillArr:getSize() do
					self.roleSkillArr[i]:setShow(false);
				end
			end
		end
	end
end

function Lua_FightMainWindow:checkOperate()
	self.roundObj:SetActive(true)
	
	local list;
	if self._recordVo.isReplay == true then
		list = self._recordVo.templateConfig.replay_show;
	else
		list = self._recordVo.templateConfig.normal_show;
	end
	if list == nil then
		return;
	end

	local arr = Array(); -- 右下角操作按钮
	local _arr = Array(); -- 暂停操作选项按钮
	local len = #list
	for i = 1, len do
		if list[i] == 5 then -- 显示波数
			self.rotationObj:SetActive(true);
			LuaUtil.setObjPos(self.rotationObj, 0, -100.5, 0);
			LuaUtil.setObjPos(self.roundObj, 0, -136, 0);
		elseif list[i] == 6 then -- 分队信息
			local lineup = self._recordVo.attacker.lineup;
			if lineup ~= nil and lineup[2] ~= nil then
				arr:add(list[i]);
			end
		elseif list[i] == 11 then -- 放弃战斗
			_arr:add(list[i]);
		elseif list[i] == 12 then -- 重新开始
			_arr:add(list[i]);
		else
			arr:add(list[i]);
		end
	end
	_arr:add(13); -- 继续

	if self.operateList == nil then
		self.operateList = Array()
	end
	len = self.operateList:getSize()
	for i = 1, len do
		self.operateList[i]:setEnable(false)
	end

	self.speedIcon = nil
	len = arr:getSize()
	local index = 1
	local posY
	while len > 0 do
		icon = self.operateList[index]
		if icon == nil then
			icon = UICreate.createUIAtlasImage(self.downObject, nil, nil, 0, 0, 0, 0)
		else
			icon:setEnable(true)
		end
		posY = 63 + (index - 1) * 85
		if arr[len] == 0 then -- 加速
			icon:setAltas("fight_atlas_1", "ui_zd_button_01"..(self._recordVo.showSpeed + 3).."_n")
			self.speedIcon = icon
		elseif arr[len] == 1 then -- 跳过
			icon:setAltas("fight_atlas_1", "ui_zd_button_018_n")
		elseif arr[len] == 2 then -- BUFF
			icon:setAltas("fight_atlas_1", "xui_zd_button_028")
		elseif arr[len] == 3 then -- 暂停
			icon:setAltas("fight_atlas_1", "ui_zd_button_019_n")
		elseif arr[len] == 4 then -- 挂起
			icon:setAltas("fight_atlas_1", "ui_zd_button_021_n")
		elseif arr[len] == 6 then -- 分队信息
			icon:setAltas("fight_atlas_1", "ui_zd_button_020_n")
		end
		icon.name = arr[len]
		icon:setLocation(306, posY, 0)
		icon:addClickFuntion(self, self.onButtonClick)

		index = index + 1
		len = len - 1
	end

	if self.giveUpIcon then self.giveUpIcon:setEnable(false) end
	if self.replayIcon then self.replayIcon:setEnable(false) end
	if self.continueIcon then self.continueIcon:setEnable(false) end
	len = _arr:getSize()
	local spacingH = 180
	local w = spacingH * len
	w = - w / 2 + spacingH / 2;
	local icon
	for i = 1, len do
		icon = UICreate.createUIAtlasImage(self.maskObj, nil, nil, 0, 0, 0, 0);
		icon:setLocation(((i - 1) % len) * spacingH + w, 97, 0);
		if _arr[i] == 11 then
			if self.giveUpIcon == nil then
				self.giveUpIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "ui_zd_button_005_n", 0, 0, 0, 0)
			end
			self.giveUpIcon:setEnable(true)
			self.giveUpIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.giveUpIcon.name = _arr[i]
			self.giveUpIcon:addClickFuntion(self, self.onButtonClick)
		elseif _arr[i] == 12 then
			if self.replayIcon == nil then
				self.replayIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "ui_zd_button_004_n", 0, 0, 0, 0)
			end
			self.replayIcon:setEnable(true)
			self.replayIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.replayIcon.name = _arr[i]
			self.replayIcon:addClickFuntion(self, self.onButtonClick)
		elseif _arr[i] == 13 then
			if self.continueIcon == nil then
				self.continueIcon = UICreate.createUIAtlasImage(self.maskObj, "fight_atlas_1", "ui_zd_button_006_n", 0, 0, 0, 0)
			end
			self.continueIcon:setEnable(true)
			self.continueIcon:setLocation(((i - 1) % len) * spacingH + w, 97, 0)
			self.continueIcon.name = _arr[i]
			self.continueIcon:addClickFuntion(self, self.onButtonClick)
		end
    end
end

function Lua_FightMainWindow:onButtonClick(data)
	if type(data) == "userdata" then
		data = data.name;
	end
	data = tonumber(data);

	if data == 0 then -- 加速
		self:onSpeed();
	elseif data == 1 then -- 跳过
		self:onSkip();
	elseif data == 2 then -- BUFF
		self:onCheckBuff();
	elseif data == 3 then -- 暂停
		self:onPause();
	elseif data == 4 then -- 挂起
		self:onHang();
	elseif data == 6 then -- 分队信息
		self:onCheckQueue();
	elseif data == 11 then -- 放弃战斗
		self:onGiveUp();
	elseif data == 12 then -- 重新开始
		self:onReplay();
	elseif data == 13 then -- 继续
		self:onContinue();
	end
end

function Lua_FightMainWindow:onSpeedChange()
	if self.speedIcon then
		self.speedIcon:setAltas("fight_atlas_1", "ui_zd_button_01"..(self._recordVo.showSpeed + 3).."_n")
	end
	if self.bossHurtPanel ~= nil then
		self.bossHurtPanel:setSpeedRate(self._recordVo.speedRate);
	end
end

-- 速度
function Lua_FightMainWindow:onSpeed()
	local idx = self._recordVo.speedIdx;
	local vipVo = DataCenter.vipData.curVipLevelVo;
	if vipVo ~= nil and vipVo.fightPlaySpeed ~= nil then
		if idx >= #vipVo.fightPlaySpeed then
			idx = 1;
		else
			idx = idx + 1;
		end
	end

	local templateCfg = self._recordVo.templateConfig;
	if idx > 1 and self._recordVo.isReplay ~= true and templateCfg ~= nil and templateCfg.speedCond ~= nil and #templateCfg.speedCond >= idx - 1 then
		if DataCenter.funcOpenData:isOpened(templateCfg.speedCond[idx - 1], true) == false then
			return;
		end
	end

	self._recordVo.speedIdx = idx;
end

-- 跳过
function Lua_FightMainWindow:onSkip()
	if not self:checkCanSkip() or self.isPressSkip == true then
		return;
	end
	self.isPressSkip = true

	self._recordVo:checkResult()
	local player = DataCenter.fightData:getFightPlayerById(self._recordId)
	player:playEnd(true)
end

function Lua_FightMainWindow:checkCanSkip()
	if self._recordVo ~= nil and self._recordVo.isReplay ~= true then
		if self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_ARENA then
			local limitTimes = DataCenter.arenaUtil:getConstConfig("skip_fight_times", 1);
			if DataCenter.arenaData.fight_times < limitTimes then
				OperateAlert.show(LanUtil.formateStr(303024, tostring(limitTimes)));
				return false;
			end
		end

		local templateCfg = self._recordVo.templateConfig;
		if self._recordVo.isReplay ~= true and templateCfg ~= nil and templateCfg.skipCond ~= nil then
			if not DataCenter.funcOpenData:isOpened(templateCfg.skipCond, true) then
				return false;
			end
		end
	end
	return true;
end

-- 状态
function Lua_FightMainWindow:onCheckBuff()
	if self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_1 
		or self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_INFINITYHALL_2 then
		Lua_WindowUtil.openWin("Lua_InfinityHallBuffWindow", Lua_WinParam.ACTION_OPEN);
	else
		Lua_WindowUtil.openWin("Lua_FightOverallBuffWindow", Lua_WinParam.ACTION_OPEN, self._recordId);
	end
end

-- 暂停
function Lua_FightMainWindow:onPause()
	self.maskObj:SetActive(true);
	DataCenter.fightData:controllFightPlay(self._recordId, false);
end

-- 切换到后台
function Lua_FightMainWindow:onHang()
	if self._recordVo.isReplay ~= true then
		if not DataCenter.funcOpenData:isOpened(self._recordVo.templateConfig.hangCond, true) then
			return;
		end
	end
	
	if self.isPressHang == nil then -- 防止多次点击挂起按钮
		self.isPressHang = true;
		if self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_MAINLINE then
			local vo = DataCenter.funcPathUtil:getFuncPathVo(1005);
			if not vo.isShowing then
				DataCenter.funcPathUtil:gotoFunction(1005, true, false);
			end
		end
		DataCenter.fightData:hideFightToBackStageByRecordId(self._recordId);
		DataCenter.fightData:showNextResult(); -- 切换到后台后，是否有结算界面需显示
		DataCenter.funcPathUtil:clearFightRecordFuncPath(self._recordId);
	end
end

-- 查看队列
function Lua_FightMainWindow:onCheckQueue()
	local player = DataCenter.fightData:getFightPlayerById(self._recordId);
	if player ~= nil then
		local data = {
			attackerTeamIdx = player.attackerTeamIdx, -- 攻方分队索引
			defenderTeamIdx = player.defenderTeamIdx, -- 守方分队索引
			attackerLineup = self._recordVo.attacker.lineup, -- 攻方阵容
			defenderLineup = self._recordVo.defender.lineup; -- 守方阵容
		};
		Lua_WindowUtil.openWin("Lua_FightQueueWindow", Lua_WinParam.ACTION_OPEN, data);
	end
end

function Lua_FightMainWindow:onBlackMaskClick(go)
	self.maskObj:SetActive(false);
	DataCenter.fightData:controllFightPlay(self._recordId, true);
end

-- 放弃
function Lua_FightMainWindow:onGiveUp()
	self.maskObj:SetActive(false);
	if self._recordVo.isIgnoreResult == false then
		Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightResult(self._recordId, 2, self.curRotation);
	end
	DataCenter.fightData:removeFightResult(self._recordId);
	DataCenter.fightData:removeFight(self._recordId);
end

-- 重播
function Lua_FightMainWindow:onReplay()
	self.maskObj:SetActive(false);
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightResult(self._recordId, 2, self.curRotation);

	DataCenter.fightData:removeFightResult(self._recordId);
	local msg = DataCenter.fightData:getSendFightMsg(self._recordVo.templateId);
	if msg then
		DataCenter.fightData.curPlayFightRecordId = 0
		DataCenter.fightData.removeFightId = self._recordId
		sendMsg(10102001, msg);
	else
		self:onSkillHurtUpdate(0)
		DataCenter.fightData:replayFight(self._recordId);
	end
end

-- 继续
function Lua_FightMainWindow:onContinue()
	self.maskObj:SetActive(false);
	DataCenter.fightData:controllFightPlay(self._recordId, true);
end

function Lua_FightMainWindow:createPanel()
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_STARTRIAL then
		local arr = DataCenter.starTrialUitl:getStageVo(self._recordVo.stageId).starCondArr;
		self:createStarPanel()
		self.starPanel:setData(arr);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_CHAOSFOREST then -- BOSS伤害
		if self.bossHurtPanel == nil then
			self.bossHurtPanel = Lua_FightBossHurtPanel.new(self.topObject);
		end
		self.bossHurtPanel:setData(self.templateId, self._recordVo.stageId, self._recordVo.speedRate);
	elseif self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE then
		self:createGradePanel()
	elseif self._recordVo.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_MORE then
		self:createGradePanel()
		self:createTeamUpPanel()
	end
end

-- 战斗星级
function Lua_FightMainWindow:createStarPanel()
	if self.starPanel == nil then
		self.starPanel = Lua_FightStarPanel.new(self.topObject);
		self.starPanel:setRectAnchor(1);
		self.starPanel:setLocation(-160, -240.5, 0)
	end
end

-- 战斗评级
function Lua_FightMainWindow:createGradePanel()
	self.roundObj:SetActive(false);
	if self.gradePanel == nil then
		self.gradePanel = Lua_FightGradePanel.new(self.topObject);
		self.gradePanel:setLocation(171, -314, 0);
	end
	self.gradePanel:setShowHide(true);
	self.gradePanel:setAutoHide(3);
end

-- 战斗组队
function Lua_FightMainWindow:createTeamPanel()
	if self.teamUpPanel == nil then
		self.teamUpPanel = Lua_FightTeamUpPanel.new(self.topObject)
		self.teamUpPanel:setLocation(0, -245, 0)
	end
end

function Lua_FightMainWindow:onUpdateCheck(recordId)
	if recordId == self._recordId then
		if self.starPanel then
			self.starPanel:updateData()
		end
	end
	if self.teamUpPanel then
		self.teamUpPanel:updateHp()
	end
end

function Lua_FightMainWindow:clearPanel()
	if self.bossHurtPanel then
		self.bossHurtPanel:dispose()
		self.bossHurtPanel = nil
	end
	if self.starPanel then
		self.starPanel:dispose()
		self.starPanel = nil
	end
	if self.gradePanel then
		self.gradePanel:dispose()
		self.gradePanel = nil
	end
	if self.teamUpPanel then
		self.teamUpPanel:dispose()
		self.teamUpPanel = nil
	end
end