-- 组队战斗伤害总览
checkRequire("Lua_FightOverallHurtWindow");
Lua_FightMoreHurtWindow = class("Lua_FightMoreHurtWindow", Lua_FightOverallHurtWindow);
function Lua_FightMoreHurtWindow:ctor(p)
	self:superCall("ctor");

	self.windowName = "Lua_FightMoreHurtWindow";
	self.skinName = "FightOverallHurtWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_FightMoreHurtWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.dragList = Lua_DragList.new(self.content, 510, 40, Lua_AxisDefine.Horizontal);
    self.dragList:setListCell(Lua_FightMoreHurtCell, 170, 40, 1);
    self.dragList:setCellSpacing(10, 5);
    self.dragList:setLocation(0, -626);

    self:addLuaEvent("ON_MORE_HERT_CELL",self,self.onMoreHertInfo)
end

function Lua_FightMoreHurtWindow:showWin(param)
	self.dragList:setArrayData(param);
	local index = self:getSelfIndex(param);
	self.dragList:setSelected(index);
	self:onMoreHertInfo(param[index]);
end

function Lua_FightMoreHurtWindow:getSelfIndex(list)
	for i=1,#list do
		if tonumber(list[i].attacker.id) == DataCenter.roleData.roleId then
			return i;
		end
	end
	return 1;
end

function Lua_FightMoreHurtWindow:onMoreHertInfo(data)
	if self.tag_id == tonumber(data.attacker.id) then
		return;
	end
	self.tag_id = tonumber(data.attacker.id);
	self:updateHurtInfo(data);
end

function Lua_FightMoreHurtWindow:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end
	self:superCall("dispose");
end




















--页签列表
Lua_FightMoreHurtCell = class("Lua_FightMoreHurtCell", Lua_ListCell);
function Lua_FightMoreHurtCell:ctor(p)
    self:superCall("ctor", p);
end

function Lua_FightMoreHurtCell:buildShowItem()
    self:superCall("buildShowItem");
    self.bg = UICreate.createUIAtlasImage(self.content, "common_altas_1", "ui_common_itembg_06", 0, 0, 170, 40);

    self.des = UICreate.createLabel(self.content, nil, -75, 0, 100, 35, 24);
    self.des.pivot = UIUtils.Pivot.Left;
    self.des.fontName = Lua_MyUISettings.fangzhengFontName;
    self.des.alignmentValue = 3;
    self.des.horizontalOverflowValue = 1;
end

function Lua_FightMoreHurtCell:setData(data)
    if data == nil then
        return;
    end
    self.data = data;
    self.des.text = data.attacker.name;
end

function Lua_FightMoreHurtCell:onPressClick()
	Lua_MsgUtil.callFunc("ON_MORE_HERT_CELL", self.data);
	return true;
end

function Lua_FightMoreHurtCell:onSelectionChange(bSelect)
    self:superCall("onSelectionChange", bSelect);
    if bSelect == true then
        self.bg:setAltas("common_altas_1","ui_common_itembg_04");
    else
        self.bg:setAltas("common_altas_1","ui_common_itembg_03");
    end
end

function Lua_FightMoreHurtCell:dispose()
    self.data = nil;
    self:superCall("dispose");
end
