Lua_LineupAureoleIconItem = class("Lua_LineupAureoleIconItem", Lua_DisplayObject);
function Lua_LineupAureoleIconItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_LineupAureoleIconItem:buildShowItem()
	self:superCall("buildShowItem");

	self.icon = UICreate.createUIAtlasImage(self.content, "hero_altas_1", "ui_zd_icon_002", 0, 0, 0, 0);
	self.icon:addClickFuntion(self, self.onAureoleClick)
end

function Lua_LineupAureoleIconItem:dispose()
	self:superCall("dispose");
end

function Lua_LineupAureoleIconItem:setData(data, templateId)
	self.templateId = templateId;
	self.aureole_id = DataCenter.heroLineupUtil:getAureoleId(data);
	if templateId ~= nil and (templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE 
		or templateId == Lua_FightDefine.TEMPLATE_ID_COPY_MORE) then
		self.icon:setAltas("hero_altas_1", "halo01");
	else
		local config = getConfig({ "hero_camp_aureole", self.aureole_id });
		if config == nil then
			self.icon:setAltas("hero_altas_1", "ui_zd_icon_002");
		else
			self.icon:setAltas("hero_altas_1", config.sprite);
		end
	end
end

function Lua_LineupAureoleIconItem:onAureoleClick(go)
	if self.aureole_id == nil then
		return;
	end
	if self.templateId ~= nil then
		if self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_SINGLE or self.templateId == Lua_FightDefine.TEMPLATE_ID_COPY_MORE then
			OperateAlert.showLangValue(420126);
			return;
		end
	end
	Lua_WindowUtil.openWin("Lua_HeroLineupAureoleWindow", Lua_WinParam.ACTION_OPEN, self.aureole_id);
end