checkRequire("Lua_FightResultBaseWindow");
Lua_ClimbTowerFightFailWindow = class("Lua_ClimbTowerFightFailWindow", Lua_FightResultBaseWindow);
function Lua_ClimbTowerFightFailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ClimbTowerFightFailWindow";
	self.skinName = "ClimbTowerFightFailWindow_skin";
	self.winBgPath = "/images/fight/ui_jscg_widget_002.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self.openSound = "fight_lose_01";

	self.bIsWin = false;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_ClimbTowerFightFailWindow:buildShowItem()
	self:superCall("buildShowItem");

	if Lua_WindowUtil.isWindowShowing("Lua_ClimbTowerWindow") then
		self.btnBack:setEnable(false);
		self.btnConfirm:setLocation(0, -452, 0);
	else
		self.btnBack:setEnable(true);
		self.btnConfirm:setLocation(-174, -452, 0);
	end
	self.btnConfirm:addClickFuntion(self, self.hide);
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);
end

function Lua_ClimbTowerFightFailWindow:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ClimbTowerFightFailWindow:showWin(param)
	self:superCall("showWin", param);

	self.data = DataCenter.climbTowerUtil:getTowerConfig(param.stage_id);
	local vo = DataCenter.climbTowerData:getTowerVoById(self.data.index);
	self.openWindowName = vo.windowName;
	self.nameText.text = vo.name.."  "..self.data.name;

	self:updateFuncIcons();
end

function Lua_ClimbTowerFightFailWindow:onBtnBackClick(go)
	WindowMananger.getInstance():closeWinsExceptNever("Lua_ClimbTowerFightFailWindow");
	Lua_WindowUtil.openWin(self.openWindowName, Lua_WinParam.ACTION_OPEN, self.data.index);
	self:hide();
end