checkRequire("Lua_FightResultBaseWindow");
Lua_ClimbTowerFightWinWindow = class("Lua_ClimbTowerFightWinWindow", Lua_FightResultBaseWindow);
function Lua_ClimbTowerFightWinWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_ClimbTowerFightWinWindow";
	self.skinName = "ClimbTowerFightWinWindow_skin";
	self.openSound = "fight_win_01";
	self.winBgPath = "/images/fight/ui_jscg_widget_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);

	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_ClimbTowerFightWinWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.btnConfirm:addClickFuntion(self, self.hide);
	self.btnNext:addClickFuntion(self, self.onBtnNextClick);
end

function Lua_ClimbTowerFightWinWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.hide);
	self:clearRewardList();
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ClimbTowerFightWinWindow:showWin(param)
	self:superCall("showWin", param);

	self.data = DataCenter.climbTowerUtil:getTowerConfig(param.stage_id);
	local vo = DataCenter.climbTowerData:getTowerVoById(self.data.index);
	self.nameText.text = LanUtil.StringProfile(vo.name, Lua_SpaceDefine.SPACE_4, self.data.name);

	self:updateRewards(param.item_list);
end

function Lua_ClimbTowerFightWinWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.content, 608, 152, Lua_AxisDefine.Horizontal);
		else
			self.rewardList = Lua_DragList.new(self.content, len * 135, 152, Lua_AxisDefine.Horizontal);
		end
		self.rewardList:setLocation(0, -270, 0);
		self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 1);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.bDragEnd;
end

function Lua_ClimbTowerFightWinWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_ClimbTowerFightWinWindow:onBtnNextClick(go)
	if self.data ~= nil then
		if self.data.next ~= nil and self.data.next > 0 then
			local vo = DataCenter.climbTowerData:getTowerVoById(self.data.index);
			if vo.isLimit == true then
				OperateAlert.showLangValue(201001);
			else
				DataCenter.funcPathUtil:clearFightRecordFuncPath(self.recordId);
				Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.showData.template_id, self.data.next);
				if not Lua_WindowUtil.isWindowShowing(vo.windowName) then
					local config = DataCenter.climbTowerUtil:getTowerConfig(self.data.next);
					OperateAlert.show(LanUtil.formateStr(201022, vo.name, config.name));
				else
					Lua_CommonUtil.delayCall(5, self, self.hide); -- 容错处理  直接关闭会有一帧空白
					return;
				end
			end
		else
			OperateAlert.showLangValue(201021);
		end
	end
	self:hide();
end