-- 结算基类
checkRequire("Lua_FightTemplateConfigData");
checkRequire("Lua_FightResultRewardItem");
Lua_FightResultBaseWindow = class("Lua_FightResultBaseWindow", Lua_Window);
function Lua_FightResultBaseWindow:ctor(p)
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER
	self.isFullSizeWin = true;
	self.isFullSizeBg = true
	self.showWinBg = true;
	self.winBgPath = "";
	self.height = MainWinDefine.V_height

	self.bIsWin = false; -- 是否胜利
	self.bIsShowEff = false; -- 是否显示特效
	self.bIsShowCountTime = false; -- 是否显示倒计时
	self.bIsShowStrongerBtn = false; -- 是否显示变强助手按钮
	self.bIsShowHurtBtn = false; -- 是否显示伤害统计按钮
end

function Lua_FightResultBaseWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.resultIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 35, 321, 0, 0);

	if self.bIsWin then
		self.winBg:setUrl("/images/fight/ui_jscg_widget_001.jpg");
		self.resultIcon:setAltas("fight_atlas_2", "ui_jiesuan_wenzi_01");
	else
		self.winBg:setUrl("/images/fight/ui_jscg_widget_002.jpg");
		self.resultIcon:setAltas("fight_atlas_2", "ui_jiesuan_wenzi_03");
	end

	if self.bIsShowCountTime then
		self.closeText = UICreate.createLabel(self.content, nil, 0, 53.5, 100, 31, 24);
		self.closeText.anchorValue = 7;
		self.closeText.pivotValue = 4;
		self.closeText.alignmentValue = 4;
		self.closeText.horizontalOverflowValue = 1;
		self.closeText.colorStr = Lua_ColorDefine.transColorStr("F4F0ED");
	end

	if self.bIsShowStrongerBtn then
		self.strongerBtn = UICreate.createUIAtlasImage(self.content, "fight_atlas_2", "ui_jiesuan_button_001_n", 95, 85.5, 0, 0);
		self.strongerBtn.anchorValue = 6;
		self.strongerBtn:addClickFuntion(self, self.onBtnStrongerClick);
	end

	if self.bIsShowHurtBtn then
		self.hurtBtn = UICreate.createUIAtlasImage(self.content, "fight_atlas_2", "ui_jiesuan_button_002_n", -83.5, 85.5, 0, 0);
		self.hurtBtn.anchorValue = 8;
		self.hurtBtn:addClickFuntion(self, self.onBtnHurtClick);
	end

    self:addLuaEvent("CHECK_REWARD_CLICK", self, self.cancelCountdown);
end

function Lua_FightResultBaseWindow:dispose()
	self:onRemove()
	self:removeFuncIcons();
	DataCenter.funcPathUtil:checkFightRecordFuncPath(self.recordId);
	self:superCall("dispose");
end

function Lua_FightResultBaseWindow:hide()
	self:onRemove()
	local winNamme = DataCenter.fightData:showNextResult();
	if winNamme ~= self.windowName then
		self:superCall("hide");
	end
end

-- 记录该关卡是否已弹出结算界面，引导用
function Lua_FightResultBaseWindow:recordMainLineResult()
	if self.bIsWin and self.showData ~= nil then
		local config = Lua_FightTemplateConfigData.getConfigData(self.showData.template_id)
		if config and config.sys_type == Lua_FightDefine.FIGHT_TYPE_MAINLINE then -- 主线
			DataCenter.fightData:recordFightResult(Lua_FightDefine.FIGHT_TYPE_MAINLINE, self.showData.stage_id);
			Lua_MsgUtil.callFunc("UPDATE_MAINLINE_INFO");
		end
	end
end

function Lua_FightResultBaseWindow:onRemove()
	self:endTimer()
	DataCenter.popupWinManager:removeDataByName(self.windowName)
	DataCenter.fightData:removeFightResult(self.recordId)
	DataCenter.fightData:removeFight(self.recordId)
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_EXPEDITION then -- 边境远征
		Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sHaveHeroList()
	end
end

function Lua_FightResultBaseWindow:showWin(param)
	self:superCall("showWin", param);
	self.recordId = tonumber(param.record_id);
	self.templateId = tonumber(param.template_id);
	DataCenter.fightData.curShowResultRecordId = self.recordId;
	self:initCountTime();
end

-- 初始化倒计时
function Lua_FightResultBaseWindow:initCountTime()
	self:endTimer();
	if self.bIsShowCountTime then
		self.countTime = DataCenter.fightUtil.resultWinCloseTime;
		self.closeText.text = LanUtil.formateStr(302003, tostring(self.countTime));
		self:startTimer();
	end
end

function Lua_FightResultBaseWindow:startTimer()
	if self.bTimer ~= true then
		self.bTimer = true;
		self:addTimer("Lua_FightResultBaseWindow", 1, self, self.onTimer, nil, -1);
	end
end

function Lua_FightResultBaseWindow:endTimer()
	if self.bTimer == true then
		self.bTimer = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_FightResultBaseWindow:onTimer()
	self.countTime = self.countTime - 1;
	if self.countTime <= 0 then
		self:endTimer();
		self:hide();
		return;
	end
	self.closeText.text = LanUtil.formateStr(302003, tostring(self.countTime));
end

function Lua_FightResultBaseWindow:updateFuncIcons()
	local configData = Lua_FightTemplateConfigData.getConfigData(self.templateId);
	local list = configData.failOpenIcons;
	if list == nil or #list <= 0 then
		self:removeFuncIcons();
	else
		if self.iconsList == nil then
			self.iconsList = Array();
		end
		local len = self.iconsList:getSize();
		local num = #list - len;

		while (num > 0) do
			item = Lua_IconSkipItem.new(self.content);
			self.iconsList:add(item);
			num = num - 1;
		end

		while (num < 0) do
			item = self.iconsList:remove(1);
			item:dispose();
			num = num + 1;
		end

		len = self.iconsList:getSize();
		local space = 140;
		local w;
		local posX;
		local posY;
		for i = 1, len do
			item = self.iconsList[i];
			item:setClick(self, self.onIconSkip);
			item:setData(list[i]);

			w = -(space * len) / 2 + space / 2;
			posX = ((i - 1) % len) * space + w;
			posY = -150 + Mathf.Floor((i - 1) / len) * space -1;
			item:setLocation(posX, posY, 0);
		end
	end
end

function Lua_FightResultBaseWindow:removeFuncIcons()
	if self.iconsList ~= nil then
		self.iconsList:dispose();
		self.iconsList:clear();
		self.iconsList = nil;
	end
end

function Lua_FightResultBaseWindow:onIconSkip(funcPathId)
	self:cancelCountdown();
	DataCenter.guideData.ignoreGuideLimit = true;
	DataCenter.funcPathUtil:gotoFunction(funcPathId, true);
end

function Lua_FightResultBaseWindow:onBtnHurtClick(go)
	if self.showData == nil then
		return;
	end
	self:cancelCountdown();
	Lua_WindowUtil.openWin("Lua_FightOverallHurtWindow", Lua_WinParam.ACTION_OPEN, self.showData.hurt_collect);
end

function Lua_FightResultBaseWindow:onBtnStrongerClick(go)
	if self.showData == nil then
		return;
	end
	self:cancelCountdown();
	DataCenter.funcPathUtil:gotoFunction(1054);
end

-- 取消倒计时
function Lua_FightResultBaseWindow:cancelCountdown()
	self:endTimer();
	if self.closeText ~= nil then
		self.closeText.text = "";
	end
end