-- 通用战斗胜利窗口
checkRequire("Lua_FightResultBaseWindow");
Lua_FightWinResultWindow = class("Lua_FightWinResultWindow", Lua_FightResultBaseWindow);
function Lua_FightWinResultWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FightWinResultWindow";
	self.skinName = "FightWinResultWindow_skin";
	self.winBgPath = "/images/fight/ui_jscg_widget_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self.openSound = "fight_win_01";

	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_FightWinResultWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.btnSure:addClickFuntion(self, self.onBtnSureClick);
end

function Lua_FightWinResultWindow:dispose()
	if self.templateId == Lua_FightDefine.TEMPLATE_ID_EXPEDITION then -- 边境远征
		DataCenter.expeditionData:checkTips();
	end
	self:clearRewardList();
	self:superCall("dispose");
end

function Lua_FightWinResultWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateRewards(param.item_list);
end

function Lua_FightWinResultWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self.textIcon:setEnable(false);
		self.deco_1:setEnable(false);
		self.deco_2:setEnable(false);
		self:clearRewardList();
		return;
	end
	
	self.textIcon:setEnable(true);
	self.deco_1:setEnable(true);
	self.deco_2:setEnable(true);

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.content, 540, 232.5, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 4);
		else
			self.rewardList = Lua_DragList.new(self.content, len * 135, 155, Lua_AxisDefine.Horizontal);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 1);
		end
		self.rewardList:setLocation(0, -195, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.bDragEnd;
end

function Lua_FightWinResultWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_FightWinResultWindow:onBtnSureClick(go)
	self:hide();
end