-- 试炼副本战斗失败界面
checkRequire("Lua_FightResultBaseWindow");
Lua_TrialFightFailWindow = class("Lua_TrialFightFailWindow", Lua_FightResultBaseWindow);
function Lua_TrialFightFailWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TrialFightFailWindow";
	self.skinName = "TrialFightResultWindow_skin";
    self.winBgPath = "/images/fight/ui_jscg_widget_002.jpg";
    self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
    self.openSound = "fight_lose_01";
    
	self.bIsWin = false;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_TrialFightFailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.leftIcon:setEnable(false);
	self.rewardLabIcon:setEnable(false);
	self.rightIcon:setEnable(false);

	self.btnConfirm:addClickFuntion(self, self.onBtnConfirmClick);
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);

	-- if Lua_WindowUtil.isWindowShowing("Lua_TrialWindow") then
	-- 	self.btnBack:setEnable(false);
	-- 	self.btnConfirm:setLocation(0, -452, 0);
	-- else
	-- 	self.btnBack:setEnable(true);
	-- 	self.btnConfirm:setLocation(-174, -452, 0);
	-- end
end

function Lua_TrialFightFailWindow:dispose()
	self:superCall("dispose");
end

function Lua_TrialFightFailWindow:showWin(param)
	self:superCall("showWin", param);
	self:updateShowInfo();
	self:updateFuncIcons();
end

function Lua_TrialFightFailWindow:updateShowInfo()
	local id = self.showData.stage_id;
	local trialInfo = DataCenter.TrialData:getTrialEachById(id);
	local trialConstInfo = DataCenter.TrialData:getTrialTypeById(trialInfo.script_type);
	self.trialNameTxt.text = trialConstInfo.name;
	self.challengeNameTxt.text = trialInfo.name;
	
	self.trialNameTxt:resetSize();
	self.challengeNameTxt:resetSize();
	local minPosx = self.trialNameTxt.posX - self.trialNameTxt.width;
	local maxPosX = self.challengeNameTxt.posX + self.challengeNameTxt.width;
	self.titleDesBg:SetDimensions(maxPosX - minPosx + 101, 63);

	local width = maxPosX + minPosx;
	LuaUtil.setObjPos(self.titleObj, -width / 2 - 0.5, -95, 0);
end

function Lua_TrialFightFailWindow:onBtnConfirmClick(go)
	self:hide();
end

function Lua_TrialFightFailWindow:onBtnBackClick(go)
	DataCenter.funcPathUtil:gotoFunction(1011, true, false);
end