-- 试炼副本战斗胜利界面
checkRequire("Lua_FightResultBaseWindow");
Lua_TrialFightWinWindow = class("Lua_TrialFightWinWindow", Lua_FightResultBaseWindow);
function Lua_TrialFightWinWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TrialFightWinWindow";
	self.skinName = "TrialFightResultWindow_skin";
	self.winBgPath = "/images/fight/ui_jscg_widget_001.jpg";
	self:addPreLoadRes(self.winBgPath, Lua_LoadFileType.IMG);
	self.openSound = "fight_win_01";
	
	self.bIsWin = true;
	self.bIsShowCountTime = true;
	self.bIsShowHurtBtn = true;
end

function Lua_TrialFightWinWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.textIcon:setEnable(false);
	self.bg:setEnable(false);

	self.btnConfirm:addClickFuntion(self, self.onBtnConfirmClick);
	self.btnBack:addClickFuntion(self, self.onBtnBackClick);

	-- if Lua_WindowUtil.isWindowShowing("Lua_TrialWindow") then
	-- 	self.btnBack:setEnable(false);
	-- 	self.btnConfirm:setLocation(0, 244, 0);
	-- else
	-- 	self.btnBack:setEnable(true);
	-- 	self.btnConfirm:setLocation(-174, 244, 0);
	-- end
end

function Lua_TrialFightWinWindow:dispose()
	self:clearRewardList();
	self:superCall("dispose");
end

function Lua_TrialFightWinWindow:showWin(param)
	self:superCall("showWin", param);

	self:updateShowInfo();
	self:updateRewards(param.item_list);
end

function Lua_TrialFightWinWindow:updateShowInfo()
	local id = self.showData.stage_id;
	local trialInfo = DataCenter.TrialData:getTrialEachById(id);
	local trialConstInfo = DataCenter.TrialData:getTrialTypeById(trialInfo.script_type);
	self.trialNameTxt.text = trialConstInfo.name;
	self.challengeNameTxt.text = trialInfo.name;

	self.trialNameTxt:resetSize();
	self.challengeNameTxt:resetSize();
	local minPosx = self.trialNameTxt.posX - self.trialNameTxt.width;
	local maxPosX = self.challengeNameTxt.posX + self.challengeNameTxt.width;
	self.titleDesBg:SetDimensions(maxPosX - minPosx + 101, 63);

	local width = maxPosX + minPosx;
	LuaUtil.setObjPos(self.titleObj, -width / 2 - 0.5, -95, 0);
end

function Lua_TrialFightWinWindow:updateRewards(itemList)
	if itemList == nil or #itemList <= 0 then
		self:clearRewardList();
		return;
	end

	local tab = DataCenter.packData:getRewardDic(itemList);
	local arr = DataCenter.packData:getRewardList(tab);
	if self.rewardList == nil then
		local len = arr:getSize();
		if len > 4 then
			self.rewardList = Lua_DragList.new(self.content, 540, 232.5, Lua_AxisDefine.Vertical);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 4);
		else
			self.rewardList = Lua_DragList.new(self.content, len * 135, 152, Lua_AxisDefine.Horizontal);
			self.rewardList:setListCell(Lua_FightResultRewardItem, 135, 152, 1);
		end
		self.rewardList:setLocation(0, -195, 0);
	end
	self.rewardList:setArrayData(arr);
	self.rewardList.canDrag = not self.rewardList.bDragEnd;
end

function Lua_TrialFightWinWindow:clearRewardList()
	if self.rewardList ~= nil then
		self.rewardList:dispose();
		self.rewardList = nil;
	end
end

function Lua_TrialFightWinWindow:onBtnConfirmClick(go)
	self:hide();
end

function Lua_TrialFightWinWindow:onBtnBackClick(go)
	DataCenter.funcPathUtil:gotoFunction(1011, true, false);
end